﻿using System.ComponentModel;

namespace Support_128338
{
    class Model : INotifyPropertyChanged
    {
        private string _itemName;
        public string ItemName
        {
            get { return _itemName; }
            set
            {
                _itemName = value;
                OnPropertyChanged("ItemName");
            }
        }

        private string _itemType;
        public string ItemType
        {
            get { return _itemType; }
            set
            {
                _itemType = value;
                OnPropertyChanged("ItemType");
            }
        }


        private int _numberOfDecimals;
        public int NumberOfDecimals
        {
            get { return _numberOfDecimals; }
            set
            {
                if(value==0 || value==2)
                {
                    _numberOfDecimals = value;
                    OnPropertyChanged("NumberOfDecimals");
                }
            }
        }

        private double _value;
        public double Value
        {
            get { return _value; }
            set
            {
                _value = value;
                OnPropertyChanged("Value");
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }


        public object this[string propertyName]
        {
            get { return GetType().GetProperty(propertyName).GetValue(this, null); }
            set { GetType().GetProperty(propertyName).SetValue(this, value, null); }
        }

    }
}
